package comp2673assign3;

public class DoublyLinkedList<T> implements List<T> {
	
	private Node head; // sentinel node
	private Node tail; // sentinel node
	private int size; 
	
	public DoublyLinkedList() {
		size = 0; 
		head = new Node(null, null,null); 
		tail = new Node(null, head, null); 
		head.next = tail; 
	}

	@Override
	public int size() {
		// TODO Auto-generated method stub
		return size;
	}

	@Override
	public boolean isEmpty() {
		if (size == 0) {
			return true; 
		}
		return false;
	}

	@Override
	public void addToFront(T val) {
		Node n = new Node(val,head,head.next); 
		head.next = n; 
		n.next.prev = n; 
		size++; 
		
	}

	@Override
	public void addToBack(T val) {
		Node n = new Node(val, tail.prev, tail); 
		tail.prev = n; 
		n.prev.next = n; 
		size++; 
		
	}

	@Override
	public T removeFront() {
		if (isEmpty()) throw new IllegalArgumentException("List is empty");
		
		T temp = head.next.val; 
		
		head.next = head.next.next;
		head.next.prev = head; 
		size--; 
		return temp;
	}

	@Override
	public T removeBack() {
		if (isEmpty()) throw new IllegalArgumentException("List is empty");
		
		T temp = tail.prev.val; 
		
		tail.prev = tail.prev.prev; 
		tail.prev.next = tail; 
		size--; 
		
		return temp;
	}
	
	@Override
	public String toString() {
		 Node curr = head.next; 
		 String ret = ""; 
		 for(int i = 0; i < size; i++) {
			 ret += curr.val + " ";
			 curr = curr.next; 
		 }
		 
		 return ret; 
		
	}
	
	private class Node {
		private T val; 
		private Node prev; 
		private Node next; 
		
		public Node(T t, Node p, Node n) {
			val = t; 
			prev = p; 
			next = n; 
			
		}
	}

}
