/* 
 * Tara Graeve
 * COMP 2673 Assignment 3
 */

package comp2673assign3;

import java.util.Random;
import java.util.Stack;



public class Forest {
	private int[][] grid; 
	private int height; 
	private int width; 
	
	public Forest(int w, int h, double d) {
		width = w; 
		height = h; 
		grid = new int[height][width]; 
		
		Random rng = new Random(1); 
		for(int i = 0; i < grid.length; ++i) {
			for( int j = 0; j < grid[i].length; ++j) {
				if(rng.nextDouble() <= d) {
					grid[i][j] = 1; 
				} else { 
					grid[i][j] = 0; 
				}
			}
		}
		
	}
	
	
	public String toString() {
		String ret = ""; 
			for(int i = 0; i < grid.length; ++i) {
				for(int j = 0; j < grid[i].length; ++j) {
					ret += grid[i][j]; 
				}
				ret += "\n"; 
			}
		
		return ret; 
		
	}
	
	public boolean depthFirstSearch() {
		// store positions on fire
		Stack<Position> cellsToExplore = new Stack<>(); 
		Position currentPosition;
		for(int i = 0; i < width; ++i) {
			
			if(grid[0][i] == 1) {
				Position s = new Position(0,i); 
				cellsToExplore.push(s); 
				grid[0][i] = 2; // use 2 to indicate fire
			}

		}
		
		while(!cellsToExplore.isEmpty()) {
			currentPosition = cellsToExplore.pop(); 
			if(currentPosition.getR() == height-1) {
				return true; 
			}
			
	
			if (currentPosition.getR() < height-1 && grid[currentPosition.getR()+1][currentPosition.getC()] == 1) {
				Position r = new Position(currentPosition.getR()+1,currentPosition.getC()); 
				cellsToExplore.push(r); 
				grid[r.getR()][r.getC()] = 2; 
			}
			
			if (currentPosition.getR() > 0 && grid[currentPosition.getR()-1][currentPosition.getC()] == 1) {
				Position l = new Position(currentPosition.getR()-1,currentPosition.getC()); 
				cellsToExplore.push(l); 
				grid[l.getR()][l.getC()] = 2; 
			}
			

			if(currentPosition.getC() < width-1 && grid[currentPosition.getR()][currentPosition.getC()+1] == 1) {
				Position d = new Position(currentPosition.getR(),currentPosition.getC()+1); 
				cellsToExplore.push(d); 
				grid[d.getR()][d.getC()] = 2; 
			}
			
			if(currentPosition.getC() > 0 && grid[currentPosition.getR()][currentPosition.getC()-1] == 1) {
				Position u = new Position(currentPosition.getR(),currentPosition.getC()-1); 
				cellsToExplore.push(u); 
				grid[u.getR()][u.getC()] = 2; 
			}
		}
		
		return false;
			

	}
	
	public boolean breadthFirstSearch() {
		LinkedQueue<Position> cellsToExplore = new LinkedQueue<>(); 
		// store positions on fire
		Position currentPosition;
		for(int i = 0; i < width; ++i) {
			
			if(grid[0][i] == 1) {
				Position s = new Position(0,i); 
				cellsToExplore.enqueue(s); 
				grid[0][i] = 2; // use 2 to indicate fire
			}

		}
		
		while(!cellsToExplore.isEmpty()) {
			currentPosition = cellsToExplore.dequeue(); 
			if(currentPosition.getR() == height-1) {
				return true; 
			}
			
	
			if (currentPosition.getR() < height-1 && grid[currentPosition.getR()+1][currentPosition.getC()] == 1) {
				Position r = new Position(currentPosition.getR()+1,currentPosition.getC()); 
				cellsToExplore.enqueue(r); 
				grid[r.getR()][r.getC()] = 2; 
			}
			
			if (currentPosition.getR() > 0 && grid[currentPosition.getR()-1][currentPosition.getC()] == 1) {
				Position l = new Position(currentPosition.getR()-1,currentPosition.getC()); 
				cellsToExplore.enqueue(l); 
				grid[l.getR()][l.getC()] = 2; 
			}
			
			
			if(currentPosition.getC() < width-1 && grid[currentPosition.getR()][currentPosition.getC()+1] == 1) {
				Position d = new Position(currentPosition.getR(),currentPosition.getC()+1); 
				cellsToExplore.enqueue(d); 
				grid[d.getR()][d.getC()] = 2; 
			}
			
			if(currentPosition.getC() > 0 && grid[currentPosition.getR()][currentPosition.getC()-1] == 1) {
				Position u = new Position(currentPosition.getR(),currentPosition.getC()-1); 
				cellsToExplore.enqueue(u); 
				grid[u.getR()][u.getC()] = 2; 
			}
		}
		
		return false;

	}

}
