/*
 * Tara Graeve
 * Assignment 4: Expression Tree
 * COMP2673
 */

import java.util.Scanner;
import java.util.Stack;
import java.lang.Double; 

public class ExpressionTreeHelper {

	public static TreeNode<String> expressionTreeFromRPN(String rpnString) {
		Stack<TreeNode<String>> s = new Stack<>(); //store in stack 
		Scanner tokens = new Scanner(rpnString); // convert to string; scanner does all the work for us 
		
		while(tokens.hasNext()) { 
			String tok = tokens.next(); 
			try { // testing if it's a number
				Double.parseDouble(tok); 
				TreeNode<String> t = new TreeNode<>(tok); 
				s.push(t); 
			}
			catch(NumberFormatException e) { //otherwise it's an operator; pop and make node with left and right 
				TreeNode<String> right = s.pop(); 
				TreeNode<String> left = s.pop(); 
				TreeNode<String> t = new TreeNode<>(tok); 
				t.setLeft(left); 
				t.setRight(right);
				s.push(t); 		
				
			}

		}
		tokens.close(); 
		return s.pop(); 

	}

	public static void printExpressionTree(TreeNode<String> t) {

		if(t.isLeaf()) System.out.print(t.getValue());
		else {
			System.out.print("(");
			printExpressionTree(t.getLeft()); // get the left side
			System.out.print(" " + t.getValue() + " "); // operator
			printExpressionTree(t.getRight()); // get the right side
			System.out.print(")");
		}

	}

	public static double evaluateExpressionTree(TreeNode<String> t) {
		if(t.isLeaf()) return Double.parseDouble(t.getValue()); // if it's a leaf just get the value 

		switch (t.getValue()) { //otherwise we need to determine if it's an operator and do the specified action 
			case "+": 
				return evaluateExpressionTree(t.getLeft()) + evaluateExpressionTree(t.getRight()); 
			case "-": 
				return evaluateExpressionTree(t.getLeft()) - evaluateExpressionTree(t.getRight()); 
			case "*": 
				return evaluateExpressionTree(t.getLeft()) * evaluateExpressionTree(t.getRight()); 
			case "/": 
				return evaluateExpressionTree(t.getLeft()) / evaluateExpressionTree(t.getRight()); 
			default: 
				throw new IllegalArgumentException(); 

		}

	}

}
