/* Tara Graeve
 * Assignment 5
 */
import java.awt.geom.Point2D;


public class SpatialTreeNode {
	private SpatialTreeNode left; 
	private SpatialTreeNode right; 
	private SpatialTreeNode parent; 
	private Point2D point; 
	private boolean isX;   // if it's not an x it's a y 
	
	public SpatialTreeNode(Point2D p) { 
		point = p; 
	}
	
	//getters
	public SpatialTreeNode getRight() {
		return right; 
	}
	
	public SpatialTreeNode getLeft() {
		return left; 
	}
	
	public SpatialTreeNode getParent() {
		return parent; 
	}
	
	public Point2D getValue() {
		return point; 
	}
	
	public int getHeight() {
		if(isLeaf()) return 0; 
		
		return 1 + Math.max(left.getHeight(),right.getHeight()); 
	}
	
	public int getDepth() {
		if(isRoot()) return 0; 
		
		return 1 + parent.getDepth(); 
	}
	
	public int getSize() {
		if(isLeaf()) return 1; 
		
		return 1 + left.getSize() + right.getSize(); 
	}
	
	//setters
	public void setLeft(SpatialTreeNode left) {
		this.left = left; 
		if(left != null) left.parent = this; // in case you want to set left to null to detach from tree 
	}
	
	public void setRight(SpatialTreeNode right) {
		this.right = right; 
		if(right != null) right.parent = this; 
		
	}
	
	public void setPoint(Point2D p) {
		point = p; 
	}
	
	public void setX() {
		isX = !isX; 
	}
	
	//helper methods
	public boolean hasLeft() {
		return left != null; 
	}
	
	public boolean hasRight() {
		return right != null; 
	}
	
	public boolean hasParent() {
		return parent != null; 
	}
	
	public boolean isRoot() {
		return parent == null; 
	}
	
	public boolean isLeaf() {
		return left == null && right == null; 
	}
	
	public boolean isInternal() {
		return !isLeaf(); 
	}
	
	public boolean isXNode() {
		return isX; 
	}
	
	// only for case when we remove parent 
	public void makeRoot() {
		parent = null; 
	}
	
	public String toString() {
		return point.toString();
	}


}
