/*
 * Tara Graeve
 * Assignment 6: Malicious Hangman
 * 11/15/19
 */

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

public class Driver {
	public static void main(String[] args) {
		Set<String> dictionary = new HashSet<>(); 
		int length; 
		int numGuesses; 
		
		// get game parameters
		Scanner keyboard = new Scanner(System.in);
		
		System.out.println("How long would you like your word to be?");
		length = keyboard.nextInt(); 
		
		System.out.println("How many guesses would you like?");
		numGuesses = keyboard.nextInt(); 

		// read in dictionary
		Scanner reader = null;
		try {
			reader = new Scanner(new FileInputStream("dictionary.txt"));

		} catch (FileNotFoundException e) {
			System.out.println("File not found");
			System.exit(1);
		}

		String next = "";
		
		while(reader.hasNext()) {
			next = reader.next(); 
			dictionary.add(next); 
		}
		
		// make hangman object 
		
		//StandardHangman hangman = new StandardHangman(dictionary,length,numGuesses); 
		//MaliciousHangman hangman = new MaliciousHangman(dictionary,length,numGuesses); 
		PartialMaliciousHangman hangman = new PartialMaliciousHangman(dictionary,length,numGuesses); 
		
		//game 
		while(!hangman.isGameOver()) {
			System.out.println("Enter a letter guess");
			String guess = keyboard.next(); 
			hangman.makeGuess(guess.charAt(0));
			System.out.println(hangman.state);
			if(hangman.getGuessesRemaining() > 1) {
				System.out.println("You have " + hangman.getGuessesRemaining() + " guesses remaining.");
			} else {
				System.out.println("You have " + hangman.getGuessesRemaining() + " guess remaining. Choose wisely...");

			}
			if(hangman.isGameWon()) {
				System.out.println("Congratulations! You Win!");
			}
			else if(hangman.isGameLost()) {
				System.out.println("Sorry! You Lost! The word was: " + hangman.getWord());
			}
		}
		
		keyboard.close(); 
	}


}
