/*
 * Tara Graeve
 * Assignment 6: Malicious Hangman
 * 11/15/19
 */

import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

public class PartialMaliciousHangman extends Hangman {
	boolean isCheating = true; 
	private Set<String> dictionary = new HashSet<>(); 
	private String word; 
	private StandardHangman stdHangman; 

	public PartialMaliciousHangman(Set<String> dictionary, int length, int guessCount) {		
		super(length, guessCount);
		Iterator<String> it = dictionary.iterator();
		
		//add if the word is the given length 
		while(it.hasNext()) {
			String next = it.next(); 
			if(next.length() == length) {
				this.dictionary.add(next);
			}
		}
		
	}

	@Override
	protected boolean makeNewGuess(char c) {
		Set<String> updatedWords = new HashSet<>(); 
		 if(isCheating) {
			// iterate over the list and add any words that don't contain that character to new dictionary 
			Iterator<String> iter = dictionary.iterator(); 
			 while(iter.hasNext()) {
			 	word = iter.next(); 
			 	if(word.indexOf(c) == -1) {
			 		updatedWords.add(word);
			 	}
			 }
			 // if we get to this point then there are no words left that don't have that character
			 // so we play normal hangman
			 if(0 == updatedWords.size()) {
				 this.isCheating = false; 
				 this.stdHangman = new StandardHangman(dictionary,length,guessesRemaining); 
			 } else {
				 dictionary = updatedWords; 
				 return false; 
			 }
		}
		
		boolean result = this.stdHangman.makeGuess(c); 
		this.state = this.stdHangman.state;

		return result;
	}
	

	@Override
	public String getWord() {
		if(isCheating) {
			//game must be lost if still cheating when game over
			if(isGameOver()) {
				return (new StandardHangman(dictionary,length,guessesRemaining)).getWord(); 
			}
			return this.toString(); 
			
		}
		
		//otherwise we're playing normal hangman! 
		return this.stdHangman.getWord(); 
	}

}
