/*
 * Tara Graeve
 * Assignment 6: Malicious Hangman
 * 11/15/19
 */

import java.util.HashSet;
import java.util.Iterator;
import java.util.Random;
import java.util.Set;

public class StandardHangman extends Hangman {
	private Set<String> dictionary = new HashSet<>(); 
	private String word; 

	public StandardHangman(Set<String> dictionary, int length, int guessCount) {		
		super(length, guessCount);
		
		Iterator<String> it = dictionary.iterator();
		
		//add if the word is the given length 
		while(it.hasNext()) {
			String next = it.next(); 
			if(next.length() == length) {
				this.dictionary.add(next);
			}
		}
		
		//get random word to play hangman with 
		Iterator<String> iter = this.dictionary.iterator();
		Random rng = new Random(); 
		int random = rng.nextInt(this.dictionary.size()+1); 
		for(int i = 0; i < random; i++) {
			word = iter.next(); 
		}
	}

	@Override
	protected boolean makeNewGuess(char c) {
		int index = word.indexOf(c); 
		char chars[] = word.toCharArray(); 
		
		// indexOf returns -1 if not in word
		// anything > than -1 means it's in the word
		if(index > -1) { 
			// if it's in the word then the state at the index it found is the character
			state[index] = c; 
			
			// check if the character is present at any other location past the index of its first appearance
			for(int i = index + 1; i < chars.length; i++) { 
				if(chars[i] == c) {
					state[i] = c; 			
				}
			}
		}
		
		//otherwise it's not in the word, so return false
		if (index < 0) {
			return false; 
		}
		
		//if it was successful return true
		return true;
	}

	@Override
	public String getWord() {
		return word; 
	}

}
