/* 
 * Tara Graeve 
 * Project 3: Emoji - ClockEmoji Class
 * 5/6/19
 */


import edu.princeton.cs.introcs.StdDraw;

public class ClockEmoji extends Emoji {
	private int hour; 
	private int minute; 

	public ClockEmoji(double x, double y, double r, int h, int m) {
		super(x, y, r);
		hour = h; 
		minute = m; 
	}

	@Override
	public void draw() { // standard size: draw each emoji 100 by 100 
		StdDraw.setPenColor(StdDraw.GRAY); 
		StdDraw.filledCircle(getCenterX(), getCenterY(), getRadius()); // blank clock emoji 
		drawHands(hour,minute); 



	}

	@Override
	public void animate() {
		if (minute == 60) {
			minute = 1; 
			if (hour == 12) {
				hour = 1; 
			} else {
				hour++; 
			} 

		}
		else {
			minute++; 
		}

	}

	public void drawHands(int h, int m) { // method to draw the clock hands in the proper position 
		// minute hand 
		StdDraw.setPenColor(StdDraw.BOOK_RED); 
		StdDraw.setPenRadius(0.005); 
		StdDraw.line(getCenterX(), getCenterY(), getCenterX() + ((getRadius()-getRadius()/20)*Math.cos((6*Math.PI*m/180) - Math.PI/2)),getCenterY() + (getRadius()*Math.sin((6*Math.PI*m/180) + Math.PI/2))); 

		// hour hand 
		StdDraw.setPenColor(StdDraw.BOOK_BLUE); 
		StdDraw.line(getCenterX(), getCenterY(), getCenterX() + ((getRadius()-getRadius()/20)*Math.cos((30*Math.PI*h/180) - Math.PI/2)),getCenterY() + (getRadius()*Math.sin((30*Math.PI*h/180) + Math.PI/2))); 


	}

}
