/* 
 * Tara Graeve 
 * Project 3: Emoji - FaceEmoji Class (Abstract)
 * 5/6/19
 */

import edu.princeton.cs.introcs.StdDraw;

public abstract class FaceEmoji extends Emoji {
	private boolean isWinking; 
	private int count = 0; 

	public FaceEmoji(double x, double y, double r) {
		super(x, y, r);
		isWinking = false; 
	}

	public void draw() {  // standard size: draw each emoji 100 by 100
		count++; 

		StdDraw.setPenColor(StdDraw.YELLOW); 
		StdDraw.filledCircle(getCenterX(), getCenterY(), getRadius()); // blank emoji face 

		if(!isWinking) { // will draw standard face if boolean isWinking is false 

			StdDraw.setPenColor(StdDraw.BLACK);
			StdDraw.filledCircle(getCenterX()+15, getCenterY()+15, getRadius()/8); // add eye
			StdDraw.filledCircle(getCenterX()-15, getCenterY()+15, getRadius()/8); // add eye 
		} else if (isWinking) { // draws winking face if boolean isWinking is true

			StdDraw.setPenColor(StdDraw.BLACK); 
			StdDraw.filledCircle(getCenterX()+15, getCenterY()+15, getRadius()/8); // add eye
			StdDraw.arc(getCenterX()-15, getCenterY()+15, getRadius()/8,0,180); // add eye that is winking 

		}
	}

	public void animate() { 
		if (count % 2 == 0) { // use count variable to determine status of isWinking; set accordingly
			isWinking = true; 
		} else {
			isWinking = false; 
		}

	}



}
