﻿Public Class GymnastSearch
    Private Sub GymnastSearch_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        'TODO: This line of code loads data into the 'TarasTwistersGymnasticsDataSet3.SortedGymnastName' table. You can move, or remove it, as needed.
        Me.SortedGymnastNameTableAdapter.Fill(Me.TarasTwistersGymnasticsDataSet.SortedGymnastName)
        'TODO: This line of code loads data into the 'TarasTwistersGymnasticsDataSet2.SortedLevel' table. You can move, or remove it, as needed.
        Me.SortedLevelTableAdapter.Fill(Me.TarasTwistersGymnasticsDataSet.SortedLevel)
        'TODO: This line of code loads data into the 'TarasTwistersGymnasticsDataSet1.GYMNAST' table. You can move, or remove it, as needed.
        Me.GYMNASTTableAdapter.Fill(Me.TarasTwistersGymnasticsDataSet.GYMNAST)
        'TODO: This line of code loads data into the 'TarasTwistersGymnasticsDataSet.GYMNAST' table. You can move, or remove it, as needed.
        Me.GYMNASTTableAdapter.Fill(Me.TarasTwistersGymnasticsDataSet.GYMNAST)
        'TODO: This line of code loads data into the 'TarasTwistersGymnasticsDataSet._EVENT' table. You can move, or remove it, as needed.
        Me.EVENTTableAdapter.Fill(Me.TarasTwistersGymnasticsDataSet._EVENT)
        'TODO: This line of code loads data into the 'TarasTwistersGymnasticsDataSet.LEVEL' table. You can move, or remove it, as needed.
        Me.LEVELTableAdapter.Fill(Me.TarasTwistersGymnasticsDataSet.LEVEL)

    End Sub

    Private Sub btnSearch_Click(sender As Object, e As EventArgs) Handles btnSearch.Click
        Try
            SearchResultsTableAdapter.FillBy(Me.TarasTwistersGymnasticsDataSet.SearchResults,
                                         Me.cboLevel.SelectedValue,
                                         Me.cboName.SelectedValue,
                                         Me.cboEvent.SelectedValue,
                                         Me.dtBegDate.Value,
                                         Me.dtEndDate.Value)
        Catch ex As Exception
            MsgBox(ex.Message,, "Error in the query")
        End Try

        Dim n As Integer
        n = Me.SearchResultsDataGridView.Rows.Count - 1
        If n = 0 Then
            MsgBox("No records found.")
        End If

        ScoreStats()

    End Sub

    Private Sub SortedLevelBindingSource_CurrentChanged(sender As Object, e As EventArgs)

    End Sub

    Private Sub ScoreStats()
        Dim sum As Decimal
        Dim dgvr As System.Windows.Forms.DataGridViewRow
        Dim max As Decimal, min As Decimal, hit As Integer
        max = 0
        min = 10 'max score is 10, therefore starting at a min of 10 captures all potential scores, whereas 0 doesn't make sense because it would just return 0
        hit = 0
        For Each dgvr In Me.SearchResultsDataGridView.Rows
            sum += dgvr.Cells("Score").Value
            If dgvr.Cells("Score").Value > max Then
                max = dgvr.Cells("Score").Value
            ElseIf dgvr.Cells("Score").Value < min And dgvr.Cells("Score").Value <> 0 Then
                min = dgvr.Cells("Score").Value
            End If

            If dgvr.Cells("Score").Value >= SetHitThreshold() Then 'make a function that dynamically does this based on event
                hit += 1
            End If
        Next dgvr

        lblMaxScore.Text = max.ToString
        lblMinScore.Text = min.ToString

        Dim count As Integer
        count = Me.SearchResultsDataGridView.Rows.Count
        lblNumScores.Text = count.ToString

        Dim avg As Decimal
        If count > 0 Then
            avg = sum / count
        Else
            avg = 0
        End If
        lblAvgScore.Text = avg.ToString("#,##0.000")

        Dim hitRate As Decimal, perc As Decimal
        If count > 0 Then
            hitRate = hit / count
            perc = hitRate * 100
        Else
            hitRate = 0
        End If
        lblHitRate.Text = perc.ToString("#,##0.00") + "%"

    End Sub

    'function sets criteria for a hit routine based on the event to account for variances in scoring across events
    'e.g. vault scores trend higher than beam scores
    Private Function SetHitThreshold()
        Dim hitScore As Decimal
        If cboEvent.SelectedValue = "VT" Then
            hitScore = 9.6
        ElseIf cboEvent.SelectedValue = "UB" Then
            hitScore = 9.4
        ElseIf cboEvent.SelectedValue = "BB" Then
            hitScore = 9.4
        ElseIf cboEvent.SelectedValue = "FX" Then
            hitScore = 9.6
        End If

        Return hitScore
    End Function

    Private Sub cboLevel_SelectedIndexChanged(sender As Object, e As EventArgs) Handles cboLevel.SelectedIndexChanged

    End Sub

    Private Sub btnClose_Click(sender As Object, e As EventArgs) Handles btnClose.Click
        Me.Close()
    End Sub

End Class
